VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DSMapBookExt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 1995-2004 ESRI
' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.

' All rights reserved under the copyright laws of the United States.

' You may freely redistribute and use this sample code, with or without modification.

' Disclaimer: THE SAMPLE CODE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
' WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
' FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ESRI OR
' CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
' OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) SUSTAINED BY YOU OR A THIRD PARTY, HOWEVER CAUSED AND ON ANY
' THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT ARISING IN ANY
' WAY OUT OF THE USE OF THIS SAMPLE CODE, EVEN IF ADVISED OF THE POSSIBILITY OF
' SUCH DAMAGE.

' For additional information contact: Environmental Systems Research Institute, Inc.

' Attn: Contracts Dept.

' 380 New York Street

' Redlands, California, U.S.A. 92373

' Email: contracts@esri.com

Option Explicit

Implements IExtension
Implements IPersistVariant

Private m_pApp As IApplication
Private WithEvents m_pMxDoc As MxDocument
Attribute m_pMxDoc.VB_VarHelpID = -1
Private m_pMapBook As IDSMapBook

Private Property Get IExtension_Name() As String
49:   IExtension_Name = "USACE_JAMB_MapBook"
End Property

Private Sub IExtension_Shutdown()
53:   Set g_pFrmMapSeries = Nothing
54:   Set m_pMapBook = Nothing
55:   Set m_pMxDoc = Nothing
56:   Set m_pApp = Nothing
End Sub

Public Property Get MapBook() As IDSMapBook
60:   Set MapBook = m_pMapBook
End Property

Private Sub IExtension_Startup(initializationData As Variant)
On Error GoTo ErrHand:
  Dim pApp As IApplication
66:   Set g_pFrmMapSeries = New frmMapSeries
67:   Set g_pFrmMapSeries.m_pApp = initializationData
68:   Set m_pMapBook = New DSMapBook
69:   Set pApp = initializationData
70:   Set m_pApp = pApp
71:   Set m_pMxDoc = pApp.Document
72:   g_bClipFlag = False
73:   g_bRotateFlag = False
74:   g_bLabelNeighbors = False
  
  Exit Sub
ErrHand:
78:   MsgBox "DSMapBookExt_Startup - " & Erl & " - " & Err.Description
End Sub

Private Property Get IPersistVariant_ID() As IUID
On Error GoTo ErrHand:
  
  Dim pUID As New UID
85:   pUID = "JAMB_Front_End.DSMapBookExt"

87:   Set IPersistVariant_ID = pUID

89:   GoTo EndProc

ErrHand:
92:   MsgBox "DSMapBookExt_ID - " & Erl & " - " & Err.Description
  Exit Property
EndProc:
95:   Set pUID = Nothing
End Property

Private Sub IPersistVariant_Load(ByVal Stream As IVariantStream)
On Error GoTo ErrHand:
'100: MsgBox "Starting DSMapBookExt.IPersistVariant_Load"

  Dim pNode As Node, pMapSeries As IDSMapSeries, lLoop As Long, sName As String
  Dim pPage As IDSMapPage
104:   Set m_pMapBook = Stream.Read
  
  'Make sure we have the tab form
  If g_pFrmMapSeries Is Nothing Then Exit Sub
  
  'Make sure our persisted map book has content
  If m_pMapBook.ContentCount = 0 Then Exit Sub
  
  'Put the content back on the form
113:   Set pMapSeries = m_pMapBook.ContentItem(0)
114:   With g_pFrmMapSeries.tvwMapBook
115:     Set pNode = .Nodes.Add("MapBook", tvwChild, "MapSeries", "Map Series", 3)
    
    'Now loop back through the list and add the tile names as nodes in the tree
118:     For lLoop = 0 To pMapSeries.PageCount - 1
119:       Set pPage = pMapSeries.Page(lLoop)
120:       sName = pPage.PageName
121:       If pPage.EnablePage Then
122:         Set pNode = .Nodes.Add("MapSeries", tvwChild, "a" & sName, pPage.PageNumber & " - " & sName, 5)
123:       Else
124:         Set pNode = .Nodes.Add("MapSeries", tvwChild, "a" & sName, pPage.PageNumber & " - " & sName, 6)
125:       End If
126:       pNode.Tag = lLoop
127:     Next lLoop
128:     .Nodes.Item("MapBook").Expanded = True
129:     .Nodes.Item("MapSeries").Expanded = True
130:   End With
  
  'If there is no active page, navigate to page 1 and make it the active page.
133:   If pMapSeries.CurrentPageNumber = -1 Then
134:     ViewPage m_pApp, pMapSeries, 0
135:   End If
  
  'Show the active page in bold in the table of contents.  'This function call seems redundant, but it is needed here.  Why?
138:   modGeneralFunctions.ShowCurrentPageAsBoldInTOC pMapSeries
  
'140: MsgBox "Ending DSMapBookExt.IPersistVariant_Load"
  
  Exit Sub
ErrHand:
144:   MsgBox "DSMapBookExt_IPersistVariant_Load - " & Erl & " - " & Err.Description
End Sub

Private Sub IPersistVariant_Save(ByVal Stream As IVariantStream)
On Error GoTo ErrHand:

'150: MsgBox "Starting DSMapBookExt.IPersistVariant_Save"

152:   Stream.Write m_pMapBook
  
'154: MsgBox "Ending DSMapBookExt.IPersistVariant_Save"
  
  Exit Sub
ErrHand:
158:   MsgBox "DSMapBookExt_IPersistVariant_Save - " & Erl & " - " & Err.Description
End Sub

Private Function m_pMxDoc_ActiveViewChanged() As Boolean
On Error GoTo ErrHand:
'Check to see if the active view is being changed back to the data view after the Map Book code has
'set the clip shape.  The g_bClipFlag variable will tell us if the Map Book code has updated the
'Clip Shape.  If it has, then we want to clear the clip shape when the user switches back to a data view.
'If the clip shape was changed by some other method, then we don't want to update it.
  Dim pDoc As IMxDocument
  
169:   If g_bClipFlag Then
'    If pSeriesOpts2.ClipData = 1 Then
171:       Set pDoc = m_pMxDoc
172:       If TypeOf pDoc.ActiveView Is IMap Then
173:         pDoc.FocusMap.ClipGeometry = Nothing
174:         g_bClipFlag = False
175:       End If
'    Else
177:       RemoveClipElement m_pMxDoc
'      g_bClipFlag = False
'    End If
180:   End If
  
182:   If g_bRotateFlag Then
183:     Set pDoc = m_pMxDoc
184:     If TypeOf pDoc.ActiveView Is IMap Then
185:       pDoc.ActiveView.ScreenDisplay.DisplayTransformation.Rotation = 0
186:       g_bRotateFlag = False
187:     End If
188:   End If
  
190:   If g_bLabelNeighbors Then
191:     Set pDoc = m_pMxDoc
192:     If TypeOf pDoc.ActiveView Is IMap Then
193:       RemoveLabels pDoc
194:       g_bLabelNeighbors = False
195:     End If
196:   End If
  
  Exit Function
ErrHand:
200:   MsgBox "DSMapBookExt_ActiveViewChanged - " & Erl & " - " & Err.Description
End Function

Private Function m_pMxDoc_BeforeCloseDocument() As Boolean
'204:   DeleteSeries
End Function

Private Function m_pMxDoc_CloseDocument() As Boolean
'204: MsgBox "Starting DSMapBookExt.m_pMxDoc_CloseDocument"
205:   DeleteSeries
'206: MsgBox "Ending DSMapBookExt.m_pMxDoc_CloseDocument"
End Function

Private Function m_pMxDoc_NewDocument() As Boolean
'210: MsgBox "Starting DSMapBookExt.m_pMxDoc_NewDocument"
215:   DeleteSeries
'212: MsgBox "Ending DSMapBookExt.m_pMxDoc_NewDocument"
End Function

Public Sub DeleteSeries()
On Error GoTo ErrHand:

'218: MsgBox "Starting DSMapBookExt.DeleteSeries"

  Dim pDoc As IMxDocument, pActive As IActiveView, pMapSeries As IDSMapSeries
  
226:   Set pDoc = m_pMxDoc
227:   Set pActive = pDoc.FocusMap
228:   Set pMapSeries = m_pMapBook.ContentItem(0)
  If pMapSeries Is Nothing Then Exit Sub
  'If pMapSeries Is Nothing Then GoTo continue_delete
231:   TurnOffClipping pMapSeries, m_pApp

'continue_delete:

232:   Set pMapSeries = Nothing
233:   m_pMapBook.RemoveContent 0
234:   g_pFrmMapSeries.tvwMapBook.Nodes.Clear
235:   g_pFrmMapSeries.tvwMapBook.Nodes.Add , , "MapBook", "Map Book", 1
  'RemoveIndicators m_pApp
237:   pActive.Refresh

'235: MsgBox "Ending DSMapBookExt.DeleteSeries"

  Exit Sub
ErrHand:
243:   MsgBox "DSMapBookExt_DeleteSeries - " & Erl & " - " & Err.Description
End Sub
