VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DSMapSeries"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.

Option Explicit

Implements IDSMapSeries
Implements IDSMapSeriesProps
Implements IDSMapSeriesOptions
Implements IDSMapSeriesOptions2  'Added 6/18/03 to support cross hatching of clip
Implements IDSMapSeriesOptions3   'Added 11/23/2004 to support selection of the tile
Implements IPersistVariant
Implements IDSMapSeriesGraphProps 'Added 02/11/2009

Private m_PageColl As Collection
Private m_bEnableSeries As Boolean
Private m_bClipData As Boolean
Private m_lClipData2 As Long  'Added 6/18/03 to support cross hatching of clip
Private m_sDataDrivenField As String
Private m_lExtentType As Long
Private m_dFixedScale As Double
Private m_bLabelNeighbors As Boolean
Private m_pLabelSymbol As ISymbol
Private m_dMargin As Double
Private m_sMarginType As String
Private m_bRotateFrame As Boolean
Private m_sRotationField As String
Private m_sDataFrameName As String
Private m_sIndexFieldName As String
Private m_sIndexLayerName As String
Private m_SuppressColl As Collection
Private m_bSupressLayers As Boolean
Private m_lTileSelection As Long
Private m_lStartNumber As Long
Private m_bSelectTile As Boolean   'Added 11/23/2004 to support selection of the tile
Private m_lPageNum As Long 'Added to store the current page number (Added 02/11/2009)

'Added these new properties which track information about a data graph. (Added 02/11/2009)
Private m_bHasDataGraphPosition As Boolean
Private m_dDataGraphXMin As Double
Private m_dDataGraphYMin As Double
Private m_dDataGraphWidth As Double
Private m_dDataGraphHeight As Double

Private Sub Class_Initialize()
54:   Set m_PageColl = New Collection
55:   Set m_SuppressColl = New Collection
56:   m_lPageNum = -1
  
  'Initialize Data Graph size properties
59:   m_bHasDataGraphPosition = False
60:   m_dDataGraphXMin = 0
61:   m_dDataGraphYMin = 0
62:   m_dDataGraphWidth = 0
63:   m_dDataGraphHeight = 0
End Sub

Private Sub Class_Terminate()
'MsgBox "DSMapSeries: Starting Class Terminate"
67:   Set m_PageColl = Nothing
68:   Set m_SuppressColl = Nothing
'MsgBox "DSMapSeries: Ending Class Terminate"
End Sub

Private Sub IDSMapSeries_AddPage(ByVal Page As JAMB_Back_End.IDSMapPage)
72:   m_PageColl.Add Page
End Sub

Private Property Get IDSMapSeries_Page(index As Long) As JAMB_Back_End.IDSMapPage
76:   If index > -1 And index < m_PageColl.Count Then
77:     Set IDSMapSeries_Page = m_PageColl.Item(index + 1)
78:   Else
79:     Set IDSMapSeries_Page = Nothing
80:   End If
End Property

Private Property Get IDSMapSeries_PageCount() As Long
84:   IDSMapSeries_PageCount = m_PageColl.Count
End Property

Private Property Let IDSMapSeries_EnableSeries(ByVal RHS As Boolean)
88:   m_bEnableSeries = RHS
End Property

Private Property Get IDSMapSeries_EnableSeries() As Boolean
92:   IDSMapSeries_EnableSeries = m_bEnableSeries
End Property

Private Sub IDSMapSeries_RemovePage(index As Long)
96:   If index > -1 And index < m_PageColl.Count Then
97:     m_PageColl.Remove index + 1
98:   End If
End Sub

Public Property Let IDSMapSeries_CurrentPageNumber(ByVal lPageNum As Long)
102:   m_lPageNum = lPageNum
End Property

Public Property Get IDSMapSeries_CurrentPageNumber() As Long
106:    IDSMapSeries_CurrentPageNumber = m_lPageNum
End Property

Private Property Let IDSMapSeriesOptions_ClipData(RHS As Boolean)
110:   m_bClipData = RHS
End Property

Private Property Get IDSMapSeriesOptions_ClipData() As Boolean
114:   IDSMapSeriesOptions_ClipData = m_bClipData
End Property

Private Property Let IDSMapSeriesOptions_DataDrivenField(RHS As String)
118:   m_sDataDrivenField = RHS
End Property

Private Property Get IDSMapSeriesOptions_DataDrivenField() As String
122:   IDSMapSeriesOptions_DataDrivenField = m_sDataDrivenField
End Property

Private Property Let IDSMapSeriesOptions_ExtentType(RHS As Long)
126:   m_lExtentType = RHS
End Property

Private Property Get IDSMapSeriesOptions_ExtentType() As Long
130:   IDSMapSeriesOptions_ExtentType = m_lExtentType
End Property

Private Property Let IDSMapSeriesOptions_FixedScale(RHS As Double)
134:   m_dFixedScale = RHS
End Property

Private Property Get IDSMapSeriesOptions_FixedScale() As Double
138:   IDSMapSeriesOptions_FixedScale = m_dFixedScale
End Property

Private Property Let IDSMapSeriesOptions_LabelNeighbors(RHS As Boolean)
142:   m_bLabelNeighbors = RHS
End Property

Private Property Get IDSMapSeriesOptions_LabelNeighbors() As Boolean
146:   IDSMapSeriesOptions_LabelNeighbors = m_bLabelNeighbors
End Property

Private Property Set IDSMapSeriesOptions_LabelSymbol(RHS As ISymbol)
150:   Set m_pLabelSymbol = RHS
End Property

Private Property Get IDSMapSeriesOptions_LabelSymbol() As ISymbol
154:   Set IDSMapSeriesOptions_LabelSymbol = m_pLabelSymbol
End Property

Private Property Let IDSMapSeriesOptions_Margin(RHS As Double)
158:   m_dMargin = RHS
End Property

Private Property Get IDSMapSeriesOptions_Margin() As Double
162:   IDSMapSeriesOptions_Margin = m_dMargin
End Property

Private Property Let IDSMapSeriesOptions_MarginType(RHS As String)
166:   m_sMarginType = RHS
End Property

Private Property Get IDSMapSeriesOptions_MarginType() As String
170:   IDSMapSeriesOptions_MarginType = m_sMarginType
End Property

Private Property Let IDSMapSeriesOptions_RotateFrame(RHS As Boolean)
174:   m_bRotateFrame = RHS
End Property

Private Property Get IDSMapSeriesOptions_RotateFrame() As Boolean
178:   IDSMapSeriesOptions_RotateFrame = m_bRotateFrame
End Property

Private Property Let IDSMapSeriesOptions_RotationField(RHS As String)
182:   m_sRotationField = RHS
End Property

Private Property Get IDSMapSeriesOptions_RotationField() As String
186:   IDSMapSeriesOptions_RotationField = m_sRotationField
End Property

Private Property Let IDSMapSeriesOptions2_ClipData(RHS As Long)
'Added 6/18/03 to support cross hatching of clip
191:   m_lClipData2 = RHS
End Property

Private Property Get IDSMapSeriesOptions2_ClipData() As Long
'Added 6/18/03 to support cross hatching of clip
196:   IDSMapSeriesOptions2_ClipData = m_lClipData2
End Property

Private Property Let IDSMapSeriesOptions3_SelectTile(RHS As Boolean)
'Added 11/12/04 to support the selection of the tile
201:   m_bSelectTile = RHS
End Property

Private Property Get IDSMapSeriesOptions3_SelectTile() As Boolean
'Added 11/12/04 to support the selection of the tile
206:   IDSMapSeriesOptions3_SelectTile = m_bSelectTile
End Property

Private Sub IDSMapSeriesProps_AddLayerToSuppress(ByVal LayerName As String)
210:   m_SuppressColl.Add LayerName
End Sub

Private Property Let IDSMapSeriesProps_DataFrameName(RHS As String)
214:   m_sDataFrameName = RHS
End Property

Private Property Get IDSMapSeriesProps_DataFrameName() As String
218:   IDSMapSeriesProps_DataFrameName = m_sDataFrameName
End Property

Private Property Let IDSMapSeriesProps_IndexFieldName(RHS As String)
222:   m_sIndexFieldName = RHS
End Property

Private Property Get IDSMapSeriesProps_IndexFieldName() As String
226:   IDSMapSeriesProps_IndexFieldName = m_sIndexFieldName
End Property

Private Property Let IDSMapSeriesProps_IndexLayerName(RHS As String)
230:   m_sIndexLayerName = RHS
End Property

Private Property Get IDSMapSeriesProps_IndexLayerName() As String
234:   IDSMapSeriesProps_IndexLayerName = m_sIndexLayerName
End Property

Private Sub IDSMapSeriesProps_RemoveLayerToSuppress(index As Long)
238:   If index > -1 And index < m_SuppressColl.Count Then
239:     m_SuppressColl.Remove index + 1
240:   End If
End Sub

Private Property Let IDSMapSeriesProps_StartNumber(RHS As Long)
244:   m_lStartNumber = RHS
End Property

Private Property Get IDSMapSeriesProps_StartNumber() As Long
248:   IDSMapSeriesProps_StartNumber = m_lStartNumber
End Property

Private Property Get IDSMapSeriesProps_SuppressLayer(index As Long) As String
252:   If index > -1 And index < m_SuppressColl.Count Then
253:     IDSMapSeriesProps_SuppressLayer = m_SuppressColl.Item(index + 1)
254:   Else
255:     IDSMapSeriesProps_SuppressLayer = ""
256:   End If
End Property

Private Property Get IDSMapSeriesProps_SuppressLayerCount() As Long
260:   IDSMapSeriesProps_SuppressLayerCount = m_SuppressColl.Count
End Property

Private Property Let IDSMapSeriesProps_SuppressLayers(ByVal RHS As Boolean)
264:   m_bSupressLayers = RHS
End Property

Private Property Get IDSMapSeriesProps_SuppressLayers() As Boolean
268:   IDSMapSeriesProps_SuppressLayers = m_bSupressLayers
End Property

Private Property Let IDSMapSeriesProps_TileSelectionMethod(RHS As Long)
272:   m_lTileSelection = RHS
End Property

Private Property Get IDSMapSeriesProps_TileSelectionMethod() As Long
276:   IDSMapSeriesProps_TileSelectionMethod = m_lTileSelection
End Property

Private Property Let IDSMapSeriesGraphProps_DataGraphHeight(RHS As Double)
280:   m_dDataGraphHeight = RHS
End Property

Private Property Get IDSMapSeriesGraphProps_DataGraphHeight() As Double
284:   IDSMapSeriesGraphProps_DataGraphHeight = m_dDataGraphHeight
End Property

Private Property Let IDSMapSeriesGraphProps_DataGraphWidth(RHS As Double)
288:   m_dDataGraphWidth = RHS
End Property

Private Property Get IDSMapSeriesGraphProps_DataGraphWidth() As Double
292:   IDSMapSeriesGraphProps_DataGraphWidth = m_dDataGraphWidth
End Property

Private Property Let IDSMapSeriesGraphProps_DataGraphXMin(RHS As Double)
296:   m_dDataGraphXMin = RHS
End Property

Private Property Get IDSMapSeriesGraphProps_DataGraphXMin() As Double
300:   IDSMapSeriesGraphProps_DataGraphXMin = m_dDataGraphXMin
End Property

Private Property Let IDSMapSeriesGraphProps_DataGraphYMin(RHS As Double)
304:   m_dDataGraphYMin = RHS
End Property

Private Property Get IDSMapSeriesGraphProps_DataGraphYMin() As Double
308:   IDSMapSeriesGraphProps_DataGraphYMin = m_dDataGraphYMin
End Property

Private Property Let IDSMapSeriesGraphProps_HasDataGraphPosition(RHS As Boolean)
312:   m_bHasDataGraphPosition = RHS
End Property

Private Property Get IDSMapSeriesGraphProps_HasDataGraphPosition() As Boolean
316:   IDSMapSeriesGraphProps_HasDataGraphPosition = m_bHasDataGraphPosition
End Property

Private Property Get IPersistVariant_ID() As esriSystem.IUID
  Dim id As New UID
321:   id = "JAMB_Back_End.DSMapSeries"
322:   Set IPersistVariant_ID = id
End Property

Private Sub IPersistVariant_Load(ByVal Stream As esriSystem.IVariantStream)
'Load the persisted parameters of the renderer
On Error GoTo ErrHand
'MsgBox "Starting DSMapSeries.IPersistVariant_Load"
  Dim lLoop As Long, lCount As Long, pPage As IDSMapPage, vClip As Variant
  Dim bClip As Boolean, vCount As Variant, lPropCount As Long

  'Added 2/18/04 to make the list of persisted properties more dynamic
333:   vCount = Stream.Read
'MsgBox "vCount: " + CStr(vCount)
335:   If UCase(TypeName(vCount)) = "BOOLEAN" Then  'Version created before the 2/18/04 update.
336:     m_bEnableSeries = CBool(vCount)
    'Added 6/18/03 to support cross hatching of area outside clip
338:     vClip = Stream.Read
339:     If UCase(TypeName(vClip)) = "BOOLEAN" Then
340:       bClip = CBool(vClip)
341:       If bClip Then
342:         m_lClipData2 = 1
343:       Else
344:         m_lClipData2 = 0
345:       End If
346:     Else
347:       m_lClipData2 = CLng(vClip)
348:     End If
349:     lPropCount = 14
350:   Else
351:     lPropCount = CLng(Mid(CStr(vCount), 21)) - 2 'Subtract two from the count.
352:     m_bEnableSeries = Stream.Read
353:     m_lClipData2 = Stream.Read
354:   End If
'MsgBox "Map Series - lPropCount: " & lPropCount & vbNewLine & "vCount: " & CStr(vCount)

  'Raise an error if property count is less than 1.
358:   If lPropCount < 1 Then Err.Raise 0, "", "Property count was less than 1."
  'Read all of the properties into a collection
  Dim Props As Collection, lx As Long
361:   Set Props = New Collection
362:   For lx = 1 To lPropCount
'MsgBox "lx: " & Str(lx)
364:     Props.Add Stream.Read
365:   Next lx
  
  'Original set of properties that every persisted map book will have.
368:   If lPropCount >= 14 Then
369:     m_sDataDrivenField = Props.Item(1)
370:     m_lExtentType = Props.Item(2)
371:     m_dFixedScale = Props.Item(3)
372:     m_bLabelNeighbors = Props.Item(4)
373:     Set m_pLabelSymbol = Props.Item(5)
374:     m_dMargin = Props.Item(6)
375:     m_sMarginType = Props.Item(7)
376:     m_bRotateFrame = Props.Item(8)
377:     m_sRotationField = Props.Item(9)
378:     m_sDataFrameName = Props.Item(10)
379:     m_sIndexFieldName = Props.Item(11)
380:     m_sIndexLayerName = Props.Item(12)
381:     m_bSupressLayers = Props.Item(13)
382:     m_lTileSelection = Props.Item(14)
383:   End If

  'Additional properties added after 2/18/04
386:   If lPropCount >= 15 Then    'Checking for start number property
387:     m_lStartNumber = Props.Item(15)
388:   Else
389:     m_lStartNumber = 1
390:   End If

  'Tile Selection added 11/23/04
393:   If lPropCount > 16 Then
394:     m_bSelectTile = Props.Item(16)
395:   Else
396:     m_bSelectTile = False
397:   End If

  'Read the 6 new properties that were added 2/11/2009
  'Current Page Number and Data Graph Properties added 02/11/2009
401:   If lPropCount >= 22 Then
'MsgBox "Map Series: lPropCount >= 22"
    'Initialize Current Page.
404:     m_lPageNum = Props.Item(17)
    'Initialize Data Graph size properties
406:     m_bHasDataGraphPosition = Props.Item(18)
407:     m_dDataGraphXMin = Props.Item(19)
408:     m_dDataGraphYMin = Props.Item(20)
409:     m_dDataGraphWidth = Props.Item(21)
410:     m_dDataGraphHeight = Props.Item(22)
411:   Else
'MsgBox "Map Series: NOT TRUE: lPropCount >= 22"
    'Initialize Current Page.
414:     m_lPageNum = -1
    'Initialize Data Graph size properties
416:     m_bHasDataGraphPosition = False
417:     m_dDataGraphXMin = 0
418:     m_dDataGraphYMin = 0
419:     m_dDataGraphWidth = 0
420:     m_dDataGraphHeight = 0
421:   End If

  'More original properties.  Writen out below the new properties because they are of variable length
424:   lCount = Stream.Read
'MsgBox "lCount (1): " + CStr(lCount)
426:   If lCount > 0 Then
427:     For lLoop = 1 To lCount
'MsgBox "lLoop: " + lLoop
429:       m_SuppressColl.Add Stream.Read
430:     Next lLoop
431:   End If

433:   lCount = Stream.Read
'MsgBox "lCount (2): " + CStr(lCount)
435:   If lCount > 0 Then
436:     For lLoop = 1 To lCount
'MsgBox "lLoop: " + Str(lLoop)
438:       Set pPage = Stream.Read
439:       If lPropCount <= 14 Then   'MapBook created before page numbers were added.  In this case we manually assign the page numbers.
440:         pPage.PageNumber = lLoop
441:       End If
442:       m_PageColl.Add pPage
443:     Next lLoop
444:   End If
'MsgBox "Ending DSMapSeries.IPersistVariant_Load without error"
  Exit Sub
ErrHand:
448:   MsgBox "MapSeries - IPersistVariant_Load - " & Erl & " - " & Err.Description
End Sub

Private Sub IPersistVariant_Save(ByVal Stream As esriSystem.IVariantStream)
'Write it all out
On Error GoTo ErrHand
  Dim lLoop As Long
  
  'Added 2/18/04 to make the list of persisted properties more dynamic
  'Count changed from 17 to 18 on 11/23/2004 to support selection of tile
  
  'Added 6 new properties is the next version of JAMB
  '(count changed from 18 to 24 on 02/11/2009
  'Stream.Write "SERIESPROPERTYCOUNT-18"
462:   Stream.Write "SERIESPROPERTYCOUNT-24"
    
464:   Stream.Write m_bEnableSeries
  
  'Added 6/18/03 to support cross hatching of area outside the clip
467:   Stream.Write m_lClipData2
468:   Stream.Write m_sDataDrivenField
469:   Stream.Write m_lExtentType
470:   Stream.Write m_dFixedScale
471:   Stream.Write m_bLabelNeighbors
472:   Stream.Write m_pLabelSymbol
473:   Stream.Write m_dMargin
474:   Stream.Write m_sMarginType
475:   Stream.Write m_bRotateFrame
476:   Stream.Write m_sRotationField
477:   Stream.Write m_sDataFrameName
478:   Stream.Write m_sIndexFieldName
479:   Stream.Write m_sIndexLayerName
480:   Stream.Write m_bSupressLayers
481:   Stream.Write m_lTileSelection
482:   Stream.Write m_lStartNumber   'Added 2/18/04
483:   Stream.Write m_bSelectTile       'Added 11/23/04 to support selection of tile
  
  'Record the current page number (added 02/11/2009)
486:   Stream.Write m_lPageNum
  'Record information about the Data Graph (added 02/11/2009)
488:   Stream.Write m_bHasDataGraphPosition
489:   Stream.Write m_dDataGraphXMin
490:   Stream.Write m_dDataGraphYMin
491:   Stream.Write m_dDataGraphWidth
492:   Stream.Write m_dDataGraphHeight
  
On Error GoTo ErrHand2
495:   Stream.Write m_SuppressColl.Count
496:   If m_SuppressColl.Count > 0 Then
497:     For lLoop = 1 To m_SuppressColl.Count
498:       Stream.Write m_SuppressColl.Item(lLoop)
499:     Next lLoop
500:   End If
501:   Stream.Write m_PageColl.Count
502:   If m_PageColl.Count > 0 Then
503:     For lLoop = 1 To m_PageColl.Count
504:       Stream.Write m_PageColl.Item(lLoop)
505:     Next lLoop
506:   End If
  Exit Sub
ErrHand:
509:   MsgBox "MapSeries - IPersistVariant_Save - " & Err.Description
  Exit Sub
ErrHand2:
512:   MsgBox "MapSeriesCOLLS - IPersistVariant_Save - " & Err.Description
End Sub
