VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PageIdentifier"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.

Option Explicit

Implements ICommand
Implements ITool

Dim m_pApp As IApplication
Dim m_sName As String

Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
22:   ICommand_Bitmap = frmResources.picIdentifier.Picture.handle
End Property

Private Property Get ICommand_Caption() As String
26:   ICommand_Caption = "Add Identifier Frame"
End Property

Private Property Get ICommand_Category() As String
30:   ICommand_Category = "USACE JAMB"
End Property

Private Property Get ICommand_Checked() As Boolean
34:   ICommand_Checked = False
End Property

Private Property Get ICommand_Enabled() As Boolean
38:   ICommand_Enabled = True
End Property

Private Property Get ICommand_HelpContextID() As Long

End Property

Private Property Get ICommand_HelpFile() As String

End Property

Private Property Get ICommand_Message() As String
50:   ICommand_Message = "Identifier Frame"
End Property

Private Property Get ICommand_Name() As String
54:   ICommand_Name = "JAMB_Front_End.PageIdentifier"
End Property

Private Sub ICommand_OnClick()
    'Get Identifer type
59:   SetWindowLong frmPageIdentifier.hwnd, GWL_HWNDPARENT, m_pApp.hwnd
60:   frmPageIdentifier.Show vbModal
61:   If frmPageIdentifier.optIdentifier(0).value Then
62:     m_sName = "Local Indicator"
63:   Else
64:     m_sName = "Global Indicator"
65:   End If
66:   Unload frmPageIdentifier
End Sub

Private Sub ICommand_OnCreate(ByVal hook As Object)
70:   Set m_pApp = hook
End Sub

Private Property Get ICommand_Tooltip() As String
74:   ICommand_Tooltip = "Add Identifier Frame"
End Property

Private Property Get ITool_Cursor() As esriSystem.OLE_HANDLE
On Error GoTo ErrHand:
79:   ITool_Cursor = frmResources.imlIcons.ListImages(1).Picture
  
  Exit Property
ErrHand:
83:   MsgBox "ITool_Cursor - " & Erl & " - " & Err.Description
End Property

Private Function ITool_Deactivate() As Boolean
87:   ITool_Deactivate = True
End Function

Private Function ITool_OnContextMenu(ByVal X As Long, ByVal Y As Long) As Boolean

End Function

Private Sub ITool_OnDblClick()

End Sub

Private Sub ITool_OnKeyDown(ByVal KeyCode As Long, ByVal Shift As Long)

End Sub

Private Sub ITool_OnKeyUp(ByVal KeyCode As Long, ByVal Shift As Long)

End Sub

Private Sub ITool_OnMouseDown(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
On Error GoTo ErrHand:
  Dim pGraphicsContainer As IGraphicsContainer, pLineSym2 As ISimpleLineSymbol
  Dim pElement As IElement, pMxApp As IMxApplication
  Dim rMapFrame As IMapFrame, pFeatLayer As IFeatureLayer
  Dim pMap As IMap, pGridLayer As IFeatureLayer
  Dim pColor2 As IColor, pColor3 As IColor
  Dim pRubberBand As IRubberBand, pScreenDisplay As IScreenDisplay
  Dim pGeometry As IGeometry, lLoop As Long, pFeatSel As IFeatureSelection
  Dim pMxDoc As IMxDocument, pLayer As ILayer, pActive As IActiveView
  Dim pRend As ISimpleRenderer, pColor As IRgbColor, pFill As ISimpleFillSymbol
  Dim pLineSym As ISimpleLineSymbol, pGeoFeatLayer As IGeoFeatureLayer
  Dim pMapBook As IDSMapBook
  Dim pSeriesProps As IDSMapSeriesProps, pFill2 As ISimpleFillSymbol
    
121:   Set pMxApp = m_pApp
122:   Set pMxDoc = m_pApp.Document
123:   Set pGraphicsContainer = pMxDoc.PageLayout
124:   Set pRubberBand = New RubberEnvelope
125:   Set pScreenDisplay = pMxApp.Display
126:   Set pGeometry = pRubberBand.TrackNew(pScreenDisplay, Nothing)
  
  'Get the index layer from the current Map Series
129:   Set pMapBook = GetMapBookExtension(m_pApp)
  If pMapBook Is Nothing Then Exit Sub
  
132:   If pMapBook.ContentCount = 0 Then
133:     MsgBox "You need to create a Map Series before adding a Page Identifier!!!"
    Exit Sub
135:   End If
136:   Set pSeriesProps = pMapBook.ContentItem(0)
  'Find the data frame
138:   Set pMap = FindDataFrame(pMxDoc, pSeriesProps.DataFrameName)
139:   If pMap Is Nothing Then
140:     MsgBox "Could not find map in PageIdentifier_OnMouseDown routine!!!"
    Exit Sub
142:   End If
  
  'Find the Index layer
145:   Set pGridLayer = FindLayer(pSeriesProps.IndexLayerName, pMap)
146:   If pGridLayer Is Nothing Then
147:     MsgBox "Could not find index layer in PageIdentifier_OnMouseDown routine!!!"
    Exit Sub
149:   End If
  
  'Create a new map and layer
152:   Set pMap = New Map
153:   pMap.Name = m_sName
154:   Set pFeatLayer = New FeatureLayer
155:   Set pRend = New SimpleRenderer
156:   Set pColor = New RgbColor    'Fill Outline symbol
157:   Set pColor2 = New RgbColor   'Fill Symbol
158:   Set pColor3 = New RgbColor   'Selection Fill symbol
159:   pColor.RGB = RGB(0, 0, 0)
160:   pColor2.NullColor = True
161:   pColor3.RGB = RGB(180, 180, 180)
162:   Set pFill = New SimpleFillSymbol
163:   Set pFill2 = New SimpleFillSymbol
164:   Set pLineSym = New SimpleLineSymbol
165:   Set pLineSym2 = New SimpleLineSymbol
166:   pLineSym.Color = pColor
167:   pLineSym.Width = 1
168:   pFill.Color = pColor2
169:   pFill.Outline = pLineSym
170:   Set pRend.Symbol = pFill
171:   Set pFeatLayer.FeatureClass = pGridLayer.FeatureClass
172:   pFeatLayer.Name = "Identifier Layer"
173:   Set pGeoFeatLayer = pFeatLayer
174:   Set pGeoFeatLayer.Renderer = pRend
175:   pLineSym2.Color = pColor2
176:   pFill2.Color = pColor3
177:   pFill2.Outline = pLineSym
178:   pMap.AddLayer pFeatLayer
179:   Set pFeatSel = pFeatLayer
180:   Set pFeatSel.SelectionSymbol = pFill2
181:   pFeatSel.SetSelectionSymbol = True
    
  'Create a new MapFrame and associate map with it
  Dim pMapFrame As IMapFrame
185:   Set pMapFrame = New MapFrame
186:   Set pMapFrame.Map = pMap
  
  'Set the position of the new map frame
189:   Set pElement = pMapFrame
190:   pElement.Geometry = pGeometry
  
  'Add mapframe to the layout
193:   pGraphicsContainer.AddElement pMapFrame, 0
194:   Set pActive = pMap
195:   pActive.Refresh
  
  'Refresh ActiveView and TOC
198:   Set pActive = pMxDoc.FocusMap
199:   pActive.Refresh
200:   pMxDoc.CurrentContentsView.Refresh 0
  
  'Deactivate the tool
203:   Set m_pApp.CurrentTool = Nothing
  
  Exit Sub
ErrHand:
207:   MsgBox "PageIdentifier_OnMouseDown - " & Erl & " - " & Err.Description
End Sub

Private Sub ITool_OnMouseMove(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)

End Sub

Private Sub ITool_OnMouseUp(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)

End Sub

Private Sub ITool_Refresh(ByVal hdc As esriSystem.OLE_HANDLE)

End Sub
