VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RegHelper"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

Option Explicit

Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" _
       (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, _
       ByVal samDesired As Long, phkResult As Long) As Long

Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" _
       (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, _
       ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, _
       lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, _
       lpdwDisposition As Long) As Long

Private Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" _
       (ByVal hKey As Long, ByVal lpClass As String, lpcbClass As Long, ByVal lpReserved As Long, _
        lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, _
        lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, _
        lpftLastWriteTime As FILETIME) As Long

Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" _
      (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, _
      ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME _
      ) As Long

Private Declare Function SHDeleteKey Lib "shlwapi.dll" Alias "SHDeleteKeyA" _
       (ByVal hKey As Long, ByVal pszSubKey As String) As Long

Private Declare Function RegSetValueExString Lib "advapi32.dll" Alias _
   "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
   ByVal Reserved As Long, ByVal dwType As Long, ByVal lpValue As _
   String, ByVal cbData As Long) As Long

Private Declare Function RegSetValueExLong Lib "advapi32.dll" Alias _
   "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
   ByVal Reserved As Long, ByVal dwType As Long, lpValue As Long, _
   ByVal cbData As Long) As Long

Private Declare Function RegQueryValueExString Lib "advapi32.dll" Alias _
   "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As _
   String, ByVal lpReserved As Long, lpType As Long, ByVal lpData _
   As String, lpcbData As Long) As Long
   
Private Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias _
   "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As _
   String, ByVal lpReserved As Long, lpType As Long, lpData As _
   Long, lpcbData As Long) As Long
   
Private Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias _
   "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As _
   String, ByVal lpReserved As Long, lpType As Long, ByVal lpData _
   As Long, lpcbData As Long) As Long

Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" _
    (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
    lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, _
    lpData As Any, lpcbData As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As _
    Any, source As Any, ByVal numBytes As Long)

Public Enum Root_Hives
   HKEY_CLASSES_ROOT = &H80000000
   HKEY_CURRENT_CONFIG = &H80000005
   HKEY_CURRENT_USER = &H80000001
   HKEY_LOCAL_MACHINE = &H80000002
   HKEY_USERS = &H80000003
End Enum

Public Enum Reg_Value_Types
    REG_SZ = 1
    REG_DWORD = 4
End Enum

Private Const ERROR_SUCCESS = 0&

'Among the constants representing error codes are the following:
Private Const ERROR_FILE_NOT_FOUND = 2&         ' Registry path does not exist
Private Const ERROR_ACCESS_DENIED = 5&          ' Requested permissions not available
Private Const ERROR_INVALID_HANDLE = 6&         ' Invalid handle or top-level key
Private Const ERROR_BAD_NETPATH = 53            ' Network path not found
Private Const ERROR_INVALID_PARAMETER = 87      ' Bad parameter to a Win32 API function
Private Const ERROR_CALL_NOT_IMPLEMENTED = 120& ' Function valid only in WinNT/2000?XP
Private Const ERROR_INSUFFICIENT_BUFFER = 122   ' Buffer too small to hold data
Private Const ERROR_BAD_PATHNAME = 161          ' Registry path does not exist
Private Const ERROR_NO_MORE_ITEMS = 259&        ' Invalid enumerated value
Private Const ERROR_BADDB = 1009                ' Corrupted registry
Private Const ERROR_BADKEY = 1010               ' Invalid registry key
Private Const ERROR_CANTOPEN = 1011&            ' Cannot open registry key
Private Const ERROR_CANTREAD = 1012&            ' Cannot read from registry key
Private Const ERROR_CANTWRITE = 1013&           ' Cannot write to registry key
Private Const ERROR_REGISTRY_RECOVERED = 1014&  ' Recovery of part of registry successful
Private Const ERROR_REGISTRY_CORRUPT = 1015&    ' Corrupted registry
Private Const ERROR_REGISTRY_IO_FAILED = 1016&  ' Input/output operation failed
Private Const ERROR_NOT_REGISTRY_FILE = 1017&   ' Input file not in registry file format
Private Const ERROR_KEY_DELETED = 1018&         ' Key already deleted
Private Const ERROR_KEY_HAS_CHILDREN = 1020&    ' Key has subkeys & cannot be deleted

Private Const KEY_CREATE_LINK = &H20
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_QUERY_VALUE = &H1

Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const STANDARD_RIGHTS_READ = &H20000
Private Const STANDARD_RIGHTS_WRITE = &H20000

Private Const SYNCHRONIZE = &H100000

Private Const KEY_READ = &H20019
Private Const KEY_WRITE = &H20006
Private Const KEY_ALL_ACCESS = &HF003F


Private Const KEY_SET_VALUE = &H2
Private Const KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))

Private Const REG_OPTION_BACKUP_RESTORE = 4
Private Const REG_OPTION_NON_VOLATILE = 0
Private Const REG_OPTION_VOLATILE = 1

Private Const REG_CREATED_NEW_KEY = &H1        ' A new key was created
Private Const REG_OPENED_EXISTING_KEY = &H2    ' An existing key was opened


Private Const ERROR_NONE = 0

Private Const ERROR_MORE_DATA = 234
Private Const REG_EXPAND_SZ = 2
Private Const REG_BINARY = 3
Private Const REG_MULTI_SZ = 7

Private Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Private Type SECURITY_ATTRIBUTES
        nLength As Long
        lpSecurityDescriptor As Long
        bInheritHandle As Long
End Type

'Private Subs and Functions

''
'Checks if a registry key exists
Private Function RegKeyExists(hKey As Long, sKeyPath As String) As Boolean
  Dim lResult As Long
  Dim hSubkey As Long
  
  lResult = RegOpenKeyEx(hKey, sKeyPath, 0, KEY_EXECUTE, hSubkey)
  ' Determine if handle is valid
  If hSubkey <> 0 Then
     RegKeyExists = True
     RegCloseKey hKey
  End If
End Function

''
'Sets a registry key value
Private Function SetValueEx(ByVal hKey As Long, sValueName As String, _
   lType As Long, vValue As Variant) As Long
       Dim lValue As Long
       Dim sValue As String
       Select Case lType
           Case REG_SZ
               sValue = vValue & Chr$(0)
               SetValueEx = RegSetValueExString(hKey, sValueName, 0&, _
                                              lType, sValue, Len(sValue))
           Case REG_DWORD
               lValue = vValue
               SetValueEx = RegSetValueExLong(hKey, sValueName, 0&, _
   lType, lValue, 4)
           End Select
   End Function
   

Private Function QueryValueEx(ByVal lhKey As Long, ByVal szValueName As String, vValue As Variant) As Long
  Dim cch As Long
  Dim lrc As Long
  Dim lType As Long
  Dim lValue As Long
  Dim sValue As String
  
  On Error GoTo QueryValueExError
    
  ' Determine the size and type of data to be read
  lrc = RegQueryValueExNULL(lhKey, szValueName, 0&, lType, 0&, cch)
  
  If lrc <> ERROR_NONE Then Error 5
  Select Case lType
    ' For strings
    Case REG_SZ:
      sValue = String(cch, 0)
      lrc = RegQueryValueExString(lhKey, szValueName, 0&, lType, sValue, cch)
      If lrc = ERROR_NONE Then
          vValue = Left$(sValue, cch - 1)
      Else
          vValue = Empty
      End If
    ' For DWORDS
    Case REG_DWORD:
      lrc = RegQueryValueExLong(lhKey, szValueName, 0&, lType, _
      lValue, cch)
      If lrc = ERROR_NONE Then vValue = lValue
    Case Else
      'all other data types not supported
      lrc = -1
  End Select
  
QueryValueExExit:
  QueryValueEx = lrc
  Exit Function
  
QueryValueExError:
  Resume QueryValueExExit
End Function
   



'Public Functions and Subs:

''
'Check for existence of key
Public Function KeyExists(KeyPath As String, Optional Hive As Long = HKEY_CURRENT_USER) As Boolean
  KeyExists = RegKeyExists(Hive, KeyPath)
End Function

''
'Create a registry key
Public Sub CreateKey(KeyPath As String, Optional Hive As Long = HKEY_CURRENT_USER)
  Dim hKey As Long, lDisposition As Long, lResult As Long
  Dim sa As SECURITY_ATTRIBUTES
  
  sa.nLength = Len(sa)
  sa.bInheritHandle = CLng(True)
  
  lResult = RegCreateKeyEx(Hive, KeyPath, 0, vbNullString, REG_OPTION_NON_VOLATILE, _
                           KEY_ALL_ACCESS, sa, hKey, lDisposition)
  If lResult = ERROR_SUCCESS Then
     If lDisposition = REG_CREATED_NEW_KEY Then
        ' Assign default values
     ElseIf lDisposition = REG_OPENED_EXISTING_KEY Then
        ' Retrieve values from existing keys
     End If
  Else
     MsgBox "Error " & lResult
  End If
End Sub

''
'Deleting a Registry Key
Public Sub DeleteKey(KeyPath As String, Optional Hive As Long = HKEY_CURRENT_USER)
  Dim lResult As Long
  lResult = SHDeleteKey(Hive, KeyPath)
End Sub

''
'Sets a new value of a Key.  Keys can have multiple values.
Public Sub SetKeyValue(KeyPath As String, ValueName As String, Value As Variant, _
Optional valueType As Long = REG_SZ, Optional Hive As Long = HKEY_CURRENT_USER)
  Dim lRetVal As Long      'result of the SetValueEx function
  Dim hKey As Long         'handle of open key
  
  'open the specified key
  lRetVal = RegOpenKeyEx(Hive, KeyPath, 0, _
                            KEY_SET_VALUE, hKey)
  lRetVal = SetValueEx(hKey, ValueName, valueType, Value)
  RegCloseKey (hKey)
End Sub

''
'Get a single value for a specified Key and Value Name
Public Function GetKeyValue(KeyPath As String, ValueName As String, _
Optional Hive As Long = HKEY_CURRENT_USER, Optional Default As Variant) As Variant
On Error GoTo hell
  Dim lRetVal As Long         'result of the API functions
  Dim hKey As Long            'handle of opened key
  Dim vValue As Variant       'setting of queried value
  
  If KeyExists(KeyPath, Hive) Then
    lRetVal = RegOpenKeyEx(Hive, KeyPath, 0, KEY_QUERY_VALUE, hKey)
    lRetVal = QueryValueEx(hKey, ValueName, vValue)
    
    'If error occurs or if value not found, return error message
    If lRetVal <> ERROR_NONE Then GoTo hell
    
    RegCloseKey (hKey)
    GetKeyValue = vValue
  Else
    GoTo hell
  End If
  Exit Function
hell:
    MsgBox "Warning: Could not find key in the Windows registry. Using Default value: " & CStr(Default)
    GetKeyValue = Default
End Function

''
'Get a collection of Name, Value pairs under a giver registry key
' returns a collection, where each element of the collection
' is a 2-element array of Variants:
' element(0) is the value name, element(1) is the value's value
Public Function GetKeyValues(ByVal KeyPath As String, Optional ByVal Hive As Long = HKEY_CURRENT_USER) _
As Collection
    Dim handle As Long
    Dim index As Long
    Dim valueType As Long
    Dim name As String
    Dim nameLen As Long
    Dim resLong As Long
    Dim resString As String
    Dim dataLen As Long
    Dim valueInfo(0 To 1) As Variant
    Dim retVal As Long
    
    ' initialize the result
    Set GetKeyValues = New Collection
    
    ' Open the key, exit if not found.
    If Len(KeyPath) Then
        If RegOpenKeyEx(Hive, KeyPath, 0, KEY_READ, handle) Then Exit Function
        ' in all cases, subsequent functions use Hive
        Hive = handle
    End If
    
    Do
        ' this is the max length for a key name
        nameLen = 260
        name = Space$(nameLen)
        ' prepare the receiving buffer for the value
        dataLen = 4096
        ReDim resBinary(0 To dataLen - 1) As Byte
        
        ' read the value's name and data
        ' exit the loop if not found
        retVal = RegEnumValue(Hive, index, name, nameLen, ByVal 0&, valueType, _
            resBinary(0), dataLen)
        
        ' enlarge the buffer if you need more space
        If retVal = ERROR_MORE_DATA Then
            ReDim resBinary(0 To dataLen - 1) As Byte
            retVal = RegEnumValue(Hive, index, name, nameLen, ByVal 0&, _
                valueType, resBinary(0), dataLen)
        End If
        ' exit the loop if any other error (typically, no more values)
        If retVal Then Exit Do
        
        ' retrieve the value's name
        valueInfo(0) = Left$(name, nameLen)
        
        ' return a value corresponding to the value type
        Select Case valueType
            Case REG_DWORD
                CopyMemory resLong, resBinary(0), 4
                valueInfo(1) = resLong
            Case REG_SZ, REG_EXPAND_SZ
                ' copy everything but the trailing null char
                resString = Space$(dataLen - 1)
                CopyMemory ByVal resString, resBinary(0), dataLen - 1
                valueInfo(1) = resString
            Case REG_BINARY
                ' shrink the buffer if necessary
                If dataLen < UBound(resBinary) + 1 Then
                    ReDim Preserve resBinary(0 To dataLen - 1) As Byte
                End If
                valueInfo(1) = resBinary()
            Case REG_MULTI_SZ
                ' copy everything but the 2 trailing null chars
                resString = Space$(dataLen - 2)
                CopyMemory ByVal resString, resBinary(0), dataLen - 2
                valueInfo(1) = resString
            Case Else
                ' Unsupported value type - do nothing
        End Select
        
        ' add the array to the result collection
        ' the element's key is the value's name
        GetKeyValues.Add valueInfo, valueInfo(0)
        
        index = index + 1
    Loop
   
    ' Close the key, if it was actually opened
    If handle Then RegCloseKey handle
End Function
