VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHelpButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

Option Explicit

Implements ICommand

Private m_pApp As IApplication

Private Sub Class_Terminate()
    Set m_pApp = Nothing
End Sub

Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
    ICommand_Bitmap = frmResources.picHelp.Picture.handle
End Property

Private Property Get ICommand_Caption() As String
    ICommand_Caption = "JAMB Help"
End Property

Private Property Get ICommand_Category() As String
    ICommand_Category = "USACE JAMB"
End Property

Private Property Get ICommand_Checked() As Boolean

End Property

Private Property Get ICommand_Enabled() As Boolean
    ICommand_Enabled = True
End Property

Private Property Get ICommand_HelpContextID() As Long

End Property

Private Property Get ICommand_HelpFile() As String

End Property

Private Property Get ICommand_Message() As String
    ICommand_Message = "Help for JAMB"
End Property

Private Property Get ICommand_Name() As String
    ICommand_Name = "JAMB_Front_End.clsHelpButton"
End Property

Private Sub ICommand_OnClick()
On Error GoTo ErrorHandler
  Const constIEPath = "C:\Program Files\Internet Explorer\iexplore.exe"
  Const constHelpFile = "C:\Program Files\CEMVN\USACE JAMB\User Guide\JAMB User Guide.htm"
  
  Dim pRegHelper As New RegHelper
  Dim strHelpPage As String
  Dim strIEPath As String
  Dim strRunPath As String
  
  'Get the help page path from the Windows registry
  strHelpPage = pRegHelper.GetKeyValue("Software\CEMVN\USACE JAMB\Paths", _
  "HelpFile", HKEY_LOCAL_MACHINE, constHelpFile)
  
  'Get the path to the IE executable from the Windows registry
  strIEPath = pRegHelper.GetKeyValue("Software\Microsoft\Windows\CurrentVersion\App Paths\IEXPLORE.EXE", _
  "", HKEY_LOCAL_MACHINE, constIEPath)

  'Show the help document.
  strRunPath = strIEPath & " " & strHelpPage
'MsgBox "strRunPath: " & strRunPath
  Shell strRunPath, 1

  'Set the reg helper to nothing.
  Set pRegHelper = Nothing

  Exit Sub
ErrorHandler:
  MsgBox "clsHelpButton_ICommand_OnClick - " & Erl & " - " & Err.Description
End Sub

Private Sub ICommand_OnCreate(ByVal hook As Object)
    Set m_pApp = hook
End Sub

Private Property Get ICommand_Tooltip() As String
    ICommand_Tooltip = "JAMB Help"
End Property

