VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMapGridButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.

Option Explicit

Implements ICommand

Private m_pApp As IApplication

Private Sub Class_Terminate()
20:     Set m_pApp = Nothing
End Sub

Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
24:     ICommand_Bitmap = frmResources.picCreateGrid.Picture.handle
End Property

Private Property Get ICommand_Caption() As String
28:     ICommand_Caption = "Manage Map Grids"
End Property

Private Property Get ICommand_Category() As String
32:     ICommand_Category = "USACE JAMB"
End Property

Private Property Get ICommand_Checked() As Boolean

End Property

Private Property Get ICommand_Enabled() As Boolean
    Dim pMx As IMxDocument
    Dim pSR As ISpatialReference
    Dim pActiveView As IActiveView
    ' Enable, if (in Layout Mode) or (using a ProjectedCoordSystem)
    ' - Refer to clsCreateGrids.CalculatePageToMapRatio for reason why
45:     Set pMx = m_pApp.Document
46:     Set pSR = pMx.FocusMap.SpatialReference
47:     Set pActiveView = pMx.ActiveView
48:     ICommand_Enabled = (TypeOf pActiveView Is IPageLayout) Or (TypeOf pSR Is IProjectedCoordinateSystem)
End Property

Private Property Get ICommand_HelpContextID() As Long

End Property

Private Property Get ICommand_HelpFile() As String

End Property

Private Property Get ICommand_Message() As String
60:     ICommand_Message = "Create/Update Map Grid polygon feature classes in ArcMap"
End Property

Private Property Get ICommand_Name() As String
64:     ICommand_Name = "JAMB_Front_End.clsMapGridButton"
End Property

Private Sub ICommand_OnClick()
    On Error GoTo eh
69:     Set frmGridSettings.m_Application = m_pApp
70:     frmGridSettings.Tickle
71:     SetWindowLong frmGridSettings.hwnd, GWL_HWNDPARENT, m_pApp.hwnd
72:     frmGridSettings.Show vbModeless
    Exit Sub
eh:
75:     If Err.Number <> 364 Then
76:         MsgBox "Error in clsMapGridButton_OnClick.  Error " & Err.Number & ": " & Erl & " - " & Err.Description
77:     End If
End Sub

Private Sub ICommand_OnCreate(ByVal hook As Object)
81:     Set m_pApp = hook
End Sub

Private Property Get ICommand_Tooltip() As String
85:     ICommand_Tooltip = "Create/Update Map Grids"
End Property
