VERSION 5.00
Begin VB.Form frmDeleteAnnotationDialog 
   Caption         =   "Delete Annotation Groups..."
   ClientHeight    =   4830
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4710
   LinkTopic       =   "Form1"
   ScaleHeight     =   4830
   ScaleWidth      =   4710
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Height          =   345
      Left            =   2400
      TabIndex        =   1
      Top             =   4440
      Width           =   1125
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   345
      Left            =   3480
      TabIndex        =   2
      Top             =   4440
      Width           =   1125
   End
   Begin VB.ListBox lstLayers 
      Height          =   4155
      ItemData        =   "frmDeleteAnnotationDialog.frx":0000
      Left            =   120
      List            =   "frmDeleteAnnotationDialog.frx":0002
      MultiSelect     =   2  'Extended
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   120
      Width           =   4455
   End
   Begin VB.Label lblMultiSelect 
      Caption         =   "Hold down Ctrl or Shift to select multiple layers."
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   4320
      Width           =   2295
   End
End
Attribute VB_Name = "frmDeleteAnnotationDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

'Author: Sam Falchook
'USACE, MVN
'Creation Date: 10/21/2008
'
'Purpose: This form provides the capability to delete page-specific annotation groups from the map series.

Option Explicit

Public m_pApp As IApplication

Private Sub cmdCancel_Click()
12:   Unload Me
End Sub

'When the user clicks OK, the application deletes page-specific annotation for each of the selected layers.
Private Sub cmdOK_Click()
On Error GoTo ErrHand:
  'Get a collection of selected layer names
  Dim layerNames As Collection
20:   Set layerNames = New Collection
  
  'Loop through each of the selected layer names in the listbox and add them to a collection
  Dim iLCount1 As Integer
  Dim bSelected As Boolean
25:   For iLCount1 = 0 To (Me.lstLayers.ListCount - 1)
26:     bSelected = Me.lstLayers.Selected(iLCount1)
27:     If bSelected Then
28:         layerNames.Add Me.lstLayers.List(iLCount1)
29:     End If
30:   Next iLCount1 'End of looping through selected layer names in listbox (Outer Loop)

32:   DeletePageSpecificAnnotationByLayerNames layerNames, m_pApp
      
34:   Unload Me
  
  Exit Sub
ErrHand:
38:   MsgBox "cmdOK_Click - " & Erl & " - " & Err.Description
End Sub


Private Sub Form_Load()
On Error GoTo ErrHand:
  
45:   InitializeLayerList
  
  Exit Sub
ErrHand:
49:   MsgBox "frmDeleteAnnotationDialog_Load - " & Erl & " - " & Err.Description
End Sub

'Populates the list box with names of feature layers in the map
Private Sub InitializeLayerList()
On Error GoTo ErrHand:
  Dim pMxDoc As IMxDocument
  Dim pActiveView As IActiveView
  Dim pMap As IMap
  
59:   Set pMxDoc = m_pApp.Document
60:   Set pActiveView = pMxDoc.ActiveView
61:   Set pMap = FindDataFrame2(m_pApp) 'get the main Map Book data frame

  'Get the 'Basic Graphics Layer' which is a container for the annotation groups.
  Dim pBasicGraphLyr As ICompositeLayer
65:   Set pBasicGraphLyr = pMap.BasicGraphicsLayer
  
  'Loop through each annotation group
  Dim lngLoopCount As Long
69:   For lngLoopCount = 0 To (pBasicGraphLyr.count - 1)
    Dim pLayer As ILayer
    Dim sLayerName As String
    
73:     Set pLayer = pBasicGraphLyr.Layer(lngLoopCount)
74:     sLayerName = pLayer.Name
'MsgBox "pLayer.Name: " & CStr(sLayerName)
        
    'Determine if the Graphic layer name contains the special keyword constant.
    Dim lSubStrLocation As Long
79:     lSubStrLocation = InStrRev(sLayerName, MAPBOOK_ANNO_CONST)
80:     If (lSubStrLocation <> 0) Then

      'Get the associated feature layer
      Dim pGraphicsLayer As IGraphicsLayer
      Dim pAssociatedLayer As ILayer
85:       Set pGraphicsLayer = pLayer
86:       Set pAssociatedLayer = pGraphicsLayer.AssociatedLayer
      
88:       If pAssociatedLayer Is Nothing Then
89:       Else
        Dim sMapLayerName As String
91:         sMapLayerName = pAssociatedLayer.Name
'MsgBox "Associated Layer Name: " & sMapLayerName
        'Add the layer names to the listbox
94:         SmartAdd sMapLayerName, Me.lstLayers
95:       End If

97:     End If 'End of Determine if the Graphic layer name contains the special keyword constant.
    
99:   Next lngLoopCount

  Exit Sub
ErrHand:
103:   MsgBox "InitializeLayerList - " & Erl & " - " & Err.Description
End Sub

'This function determines if a string is already contained
'in a listbox.  If not, the string is added.
Private Sub SmartAdd(sItem As String, lstBox As ListBox)
On Error GoTo ErrHand:
  Dim lLC As Long
  Dim bFound As Boolean
112:   bFound = False
113:   For lLC = 0 To (lstBox.ListCount - 1)
114:     If lstBox.List(lLC) = sItem Then
115:       bFound = True
116:       Exit For
117:     End If
118:   Next lLC

120:   If bFound = False Then lstBox.AddItem sItem

  Exit Sub
ErrHand:
124:   MsgBox "SmartAdd - " & Erl & " - " & Err.Description
End Sub
