Attribute VB_Name = "modGlobals"
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.


Option Explicit

Public g_pFrmMapSeries As frmMapSeries
Public g_bClipFlag As Boolean
Public g_bRotateFlag As Boolean
Public g_bLabelNeighbors As Boolean




' modFunctions.bas
' Als try to remove "What's this?" window.
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private lContextmenuWindowProc As Long
Declare Function FindWindow% Lib "user32" Alias "FindWindowA" _
    (ByVal lpclassname As Any, ByVal lpCaption As Any)

Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, _
    ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, _
    ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Const HWND_TOPMOST = -1
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const HWND_NOTOPMOST = -2

' API call to keep form top most, meaning that the ArcMap window is its parent.
Public Const GWL_HWNDPARENT = -8
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Const GWL_WNDPROC = (-4)

Public Function NoContextMenuWindowProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
On Error GoTo ErrHand:
48:   Const WM_CONTEXTMENU = &H7B
49:   If msg <> WM_CONTEXTMENU Then
50:     NoContextMenuWindowProc = CallWindowProc(lContextmenuWindowProc, hwnd, msg, wParam, lParam)
51:   End If
  
  Exit Function
ErrHand:
55:   MsgBox "NoContextMenuWindowProc - " & Erl & " - " & Err.Description
End Function
' This function starts the "NoContextMenuWindowProc" message loop
Public Sub RemoveContextMenu(lhWnd As Long)
On Error GoTo ErrHand:
60:   lContextmenuWindowProc = SetWindowLong(lhWnd, GWL_WNDPROC, AddressOf NoContextMenuWindowProc)
  
  Exit Sub
ErrHand:
64:   MsgBox "RemoveContextMenu - " & Erl & " - " & Err.Description
End Sub

Function TopMost(f As Form)
    Dim i As Integer
69:     Call SetWindowPos(f.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
End Function

Function NoTopMost(f As Form)
73:     Call SetWindowPos(f.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
End Function

Public Sub RemoveContextMenuSink(lhWnd As Long)
On Error GoTo ErrHand:
  Dim lngReturnValue As Long
79:   lngReturnValue = SetWindowLong(lhWnd, GWL_WNDPROC, lContextmenuWindowProc)
  
  Exit Sub
ErrHand:
83:   MsgBox "RemoveContextMenuSink - " & Erl & " - " & Err.Description
End Sub

Public Function FindLayer(sLayerName As String, pMap As IMap) As IFeatureLayer
' Routine for finding a layer based on a name and then returning that layer as
' a IFeatureLayer
On Error GoTo ErrHand:
  Dim lLoop As Integer
  Dim pFLayer As IFeatureLayer

93:   For lLoop = 0 To pMap.LayerCount - 1
94:     If TypeOf pMap.Layer(lLoop) Is ICompositeLayer Then
95:       Set pFLayer = FindCompositeLayer(pMap.Layer(lLoop), sLayerName, pMap)
96:       If Not pFLayer Is Nothing Then
97:         Set FindLayer = pFLayer
        Exit Function
99:       End If
100:     ElseIf TypeOf pMap.Layer(lLoop) Is IFeatureLayer Then
101:       Set pFLayer = pMap.Layer(lLoop)
102:       If UCase(pFLayer.Name) = UCase(sLayerName) Then
103:         Set FindLayer = pFLayer
        Exit Function
105:       End If
106:     End If
107:   Next lLoop
  
109:   Set FindLayer = Nothing
  
  Exit Function
  
ErrHand:
114:   MsgBox "FindLayer - " & Erl & " - " & Err.Description
End Function

Private Function FindCompositeLayer(pCompLayer As ICompositeLayer, sLayerName As String, pMap As IMap) As IFeatureLayer
On Error GoTo ErrHand:
  Dim lLoop As Long, pFeatLayer As IFeatureLayer
120:   For lLoop = 0 To pCompLayer.count - 1
121:     If TypeOf pCompLayer.Layer(lLoop) Is ICompositeLayer Then
122:       Set pFeatLayer = FindCompositeLayer(pCompLayer.Layer(lLoop), sLayerName, pMap)
123:       If Not pFeatLayer Is Nothing Then
124:         Set FindCompositeLayer = pFeatLayer
        Exit Function
126:       End If
127:     Else
128:       If TypeOf pCompLayer.Layer(lLoop) Is IFeatureLayer Then
129:         If UCase(pCompLayer.Layer(lLoop).Name) = UCase(sLayerName) Then
130:           Set FindCompositeLayer = pCompLayer.Layer(lLoop)
          Exit Function
132:         End If
133:       End If
134:     End If
135:   Next lLoop

  Exit Function
ErrHand:
139:   MsgBox "CompositeLayer - " & Erl & " - " & Err.Description
End Function

Public Function ParseOutPages(sPagesToPrint As String, pMapSeries As IDSMapSeries, bDisabled As Boolean) As Collection
On Error GoTo ErrHand:
  If Len(sPagesToPrint) = 0 Then Exit Function
  
  Dim NoSpaces() As String
  Dim sTextToSplit As String
  Dim pSeriesProps As IDSMapSeriesProps, lAdjustment As Long
  
      'Get rid of any spaces
151:       NoSpaces = Split(sPagesToPrint)
152:       sTextToSplit = Join(NoSpaces, "") 'joined with no spaces
      
  Dim aPages() As String
155:       aPages = Split(sTextToSplit, ",")
      
  Dim aPages2() As String
  
  Dim i As Long
  Dim sPage As String
  Dim lLength As Long
  Dim count As Long
  
  Dim DSPagesCollection As New Collection
  Dim lStart As Long, lEnd As Long, lPage As Long
  
  'Get the series properties so we can extract the starting page number
168:   Set pSeriesProps = pMapSeries
169:   lAdjustment = pSeriesProps.StartNumber - 1

171:   For i = 0 To UBound(aPages)
172:      aPages2 = Split(aPages(i), "-")
          
174:       If UBound(aPages2) = 1 Then
175:           lStart = CInt(aPages2(0)) - lAdjustment
176:               count = count + 1
177:           lEnd = CInt(aPages2(1)) - lAdjustment
              
179:           While lStart <> (lEnd + 1)
180:             If lStart <= pMapSeries.PageCount Then 'Added check to prevent selection of page numbers after last page.
181:                 If bDisabled Then
182:                   If pMapSeries.Page(lStart - 1).EnablePage Then
183:                     DSPagesCollection.Add pMapSeries.Page(lStart - 1)
184:                   End If
185:                 Else
186:                   DSPagesCollection.Add pMapSeries.Page(lStart - 1)
187:                 End If
188:             End If

190:             lStart = lStart + 1
191:           Wend
192:       ElseIf UBound(aPages2) < 1 Then
193:           lPage = CInt(aPages2(0)) - lAdjustment

195:           If lPage <= pMapSeries.PageCount Then 'Added check to prevent selection of page numbers after last page.
196:             If bDisabled Then
197:               If pMapSeries.Page(lPage - 1).EnablePage Then
198:                 DSPagesCollection.Add pMapSeries.Page(lPage - 1)
199:               End If
200:             Else
201:               DSPagesCollection.Add pMapSeries.Page(lPage - 1)
202:             End If
203:           End If
204:       End If
205:   Next i
206:   Set ParseOutPages = DSPagesCollection
    
  Exit Function
ErrHand:
210:   MsgBox "ParseOutPages - " & Erl & " - " & Err.Description
End Function



